-- Comparator: Library module created by VHDL Module Generator
--
-- Comparator
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity Comparator is
	generic (
		EQUAL: note := "EQUAL='1' when A = B";
		GREATER: note := "GREATER='1' when A > B";
		SMALLER: note := "SMALLER='1' when A < B";
		AWidth: integer := 16;
		BWidth: integer := 16;
		InType: type := UNSIGNED 
	);
	port (
		A: in InType(AWidth-1 downto 0);
		B: in InType(BWidth-1 downto 0);
		EQUAL,GREATER,SMALLER : out STD_LOGIC
	);
end Comparator;

architecture SMALL of Comparator is
	function max(L, R: INTEGER) return INTEGER is
	begin
	if L > R then
		return L;
	else
		return R;
	end if;
	end;
	constant width: INTEGER := max(A'length, B'length);
begin

	process (A,B)
	begin
		EQUAL <= '0';
		GREATER <= '0';
		SMALLER <= '0';
		if CONV_InType(A,width) = CONV_InType(B,width) then
			EQUAL <= '1';
		elsif CONV_InType(A,width) > CONV_InType(B,width) then
				GREATER <= '1';
			else
				SMALLER <= '1';
		end if;
	end process;

end SMALL;

architecture FAST of Comparator is
	function max(L, R: INTEGER) return INTEGER is
	begin
	if L > R then
		return L;
	else
		return R;
	end if;
	end;
	constant width: INTEGER := max(A'length, B'length);
begin

	EQUAL <= '1' when CONV_InType(A,width) = CONV_InType(B,width) else '0';
	GREATER <= '1' when CONV_InType(A,width) > CONV_InType(B,width) else '0';
	SMALLER <= '1' when CONV_InType(A,width) < CONV_InType(B,width) else '0';

end FAST;

-- Comparator: Library module ended here

