-- clock
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity clock is
	port (
		START : in STD_LOGIC;
		EN : in STD_LOGIC;
		LEDm1 : out STD_LOGIC_VECTOR(6 downto 0);
		LEDm10 : out STD_LOGIC_VECTOR(6 downto 0);
		LEDh1 : out STD_LOGIC_VECTOR(6 downto 0);
		LEDh10 : out STD_LOGIC_VECTOR(6 downto 0);
		HEXm1 : out UNSIGNED(3 downto 0);
		HEXm10 : out UNSIGNED(3 downto 0);
		HEXh1 : out UNSIGNED(3 downto 0);
		HEXh10 : out UNSIGNED(3 downto 0);
		CLK : in STD_LOGIC
	);
end clock;

architecture clock_arch of clock is

	signal ENm10,ENh1,ENh10: STD_LOGIC;
	signal HEXm1i, HEXm10i, HEXh1i, HEXh10i: UNSIGNED(3 downto 0);
	signal STARTh :STD_LOGIC;

	-- VHDL Module Generator component declarations
	component digit_m1
	generic (
		EndValue: integer := 9 
	);
	port (
		START : in STD_LOGIC;
		EN : in STD_LOGIC;
		HEX : out UNSIGNED(3 downto 0);
		LED : out STD_LOGIC_VECTOR(6 downto 0);
		CLK : in STD_LOGIC
	);
	end component;

	component digit_m10
	generic (
		EndValue: integer := 5 
	);
	port (
		START : in STD_LOGIC;
		EN : in STD_LOGIC;
		HEX : out UNSIGNED(3 downto 0);
		LED : out STD_LOGIC_VECTOR(6 downto 0);
		CLK : in STD_LOGIC
	);
	end component;

	component digit_h1
	generic (
		EndValue: integer := 9 
	);
	port (
		START : in STD_LOGIC;
		EN : in STD_LOGIC;
		HEX : out UNSIGNED(3 downto 0);
		LED : out STD_LOGIC_VECTOR(6 downto 0);
		CLK : in STD_LOGIC
	);
	end component;

	component digit_h10
	generic (
		EndValue: integer := 2 
	);
	port (
		START : in STD_LOGIC;
		EN : in STD_LOGIC;
		HEX : out UNSIGNED(3 downto 0);
		LED : out STD_LOGIC_VECTOR(6 downto 0);
		CLK : in STD_LOGIC
	);
	end component;

begin

	U_digit_m1: digit_m1
		port map (START, EN, HEXm1i, LEDm1, CLK);
	HEXm1 <= HEXm1i;

	ENm10 <= '1' when EN='1' and HEXm1i=9
		else '0';
	U_digit_m10: digit_m10
		port map (START, ENm10, HEXm10i, LEDm10, CLK);
	HEXm10 <= HEXm10i;

	STARTh <= '1' when START='1' or (HEXh1i=3 and HEXh10i=2 and ENh1='1') else '0';

	ENh1 <= '1' when ENm10='1' and HEXm10i=5
		else '0';
	U_digit_h1: digit_h1
		port map (STARTh, ENh1, HEXh1i, LEDh1, CLK);
	HEXh1 <= HEXh1i;

	ENh10 <= '1' when ENH1='1' and HEXh1i=9
		else '0';
	U_digit_h10: digit_h10
		port map (STARTh, ENh10, HEXh10i, LEDh10, CLK);
	HEXh10 <= HEXh10i;

end clock_arch;

