-- ram
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity ram is
	port (
		DATA : in STD_LOGIC_VECTOR(7 downto 0);
		ADDRESS : in STD_LOGIC_VECTOR(3 downto 0);
		WE : in STD_LOGIC;
		Q : out STD_LOGIC_VECTOR(7 downto 0)
	);
end ram;

architecture ram_arch of ram is
	signal HIGH: STD_LOGIC;

	-- VHDL Module Generator component declarations
	component LPM_RAM_DQ
	generic (
		Note: note := "RAM with Separate Input and Output Ports";
		LPM_WIDTH: integer := 8;
		LPM_TYPE: string := "LPM_RAM_DQ";
		LPM_WIDTHAD: integer := 4;
		LPM_NUMWORDS: string := "UNUSED";
		LPM_FILE: string := "UNUSED";
		LPM_INDATA: string := "UNREGISTERED";
		LPM_ADDRESS_CONTROL: string := "UNREGISTERED";
		LPM_OUTDATA: string := "UNREGISTERED";
		LPM_HINT: string := "UNUSED" 
	);
	port (
		DATA: in STD_LOGIC_VECTOR(LPM_WIDTH-1 downto 0);
		ADDRESS: in STD_LOGIC_VECTOR(LPM_WIDTHAD-1 downto 0);
		WE: in STD_LOGIC;-- := '1';
		INCLOCK: in STD_LOGIC;-- := '0';
		OUTCLOCK: in STD_LOGIC;-- := '0';
		Q: out STD_LOGIC_VECTOR(LPM_WIDTH-1 downto 0)
	);
	end component;

begin
	HIGH <= '1';

	U_LPM_RAM_DQ: LPM_RAM_DQ
		port map (DATA, ADDRESS, WE, HIGH, HIGH, Q);

end ram_arch;

