-- rom
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity rom is
	port (
		ADDRESS : in STD_LOGIC_VECTOR(3 downto 0);
		Q : out STD_LOGIC_VECTOR(7 downto 0)
	);
end rom;

architecture rom_arch of rom is

	signal HIGH : STD_LOGIC;

	-- VHDL Module Generator component declarations
	component LPM_ROM
	generic (
		Note: note := "ROM";
		LPM_WIDTH: integer := 8;
		LPM_TYPE: string := "LPM_ROM";
		LPM_WIDTHAD: integer := 4;
		LPM_NUMWORDS: string := "UNUSED";
		LPM_FILE: string := "rom.mif";
		LPM_ADDRESS_CONTROL: string := "UNREGISTERED";
		LPM_OUTDATA: string := "UNREGISTERED";
		LPM_HINT: string := "UNUSED" 
	);
	port (
		ADDRESS: in STD_LOGIC_VECTOR(LPM_WIDTHAD-1 downto 0);
		INCLOCK: in STD_LOGIC;-- := '0';
		OUTCLOCK: in STD_LOGIC;-- := '0';
		MEMENAB: in STD_LOGIC;-- := '1';
		Q: out STD_LOGIC_VECTOR(LPM_WIDTH-1 downto 0)
	);
	end component;

begin

	HIGH <= '1';
	U_LPM_ROM: LPM_ROM
		port map (ADDRESS,HIGH,HIGH,HIGH,Q);

end rom_arch;

